

#ifndef DS18B20_h
#define DS18B20_h

#include <stdio.h>
#include <stdlib.h>
#include "OneWire_barker.h"

// specific au capteur OWS DS18B20
#define THERM_CMD_CONVERTTEMP   0x44
#define THERM_CMD_RSCRATCHPAD   0xBE
#define THERM_CMD_WSCRATCHPAD   0x4E
#define THERM_CMD_CPYSCRATCHPAD 0x48
#define THERM_CMD_RECEEPROM     0xB8
#define THERM_CMD_RPWRSUPPLY    0xB4
#define THERM_CMD_SEARCHROM     0xF0
#define THERM_CMD_READROM       0x33
#define THERM_CMD_MATCHROM      0x55
#define THERM_CMD_SKIPROM       0xCC
#define THERM_CMD_ALARMSEARCH   0xEC

extern void Print (unsigned char * T1);
extern   void CPrint (const char *T1);
extern unsigned char CRam1[];
extern  unsigned char OWS_address[]; // = {0,0,0,0,0,0,0,0};
extern void CRLF1();

 
void broadcastConvert();
float getTemperature(unsigned char* address);
int getTemperatureInt(unsigned char* address);
void printSingleAddress();
 void Relecture_ID_datas(char *Po);

#endif